import 'package:tiga/src/applicationBuilder/applicationBuilderAbstract.dart';
import 'package:tiga/src/context/httpContext.dart';
import 'package:tiga/src/delegate/requestDelegate.dart';
import 'package:tiga/src/middleware/middleware.dart';

class ApplicationBuilder implements ApplicationBuilderAbstract {
  List<Middleware> _middlewares = [];

  @override
  RequestDelegate build() {
    _middlewares = _reverse(_middlewares);
    return (httpContext) {
      RequestDelegate defaultMiddleware(HttpContext _httpContext) {
        return (_httpContext) {
          _httpContext.response.statusCode = 404;
        };
      }

      var next = defaultMiddleware;

      _middlewares.forEach((middleware) {
        next = middleware(next);
      });

      return next(httpContext);
    };
  }

  @override
  ApplicationBuilderAbstract use(middleware) {
    _middlewares.add(middleware);
    return this;
  }

  List<Middleware> _reverse(arr) {
    List<Middleware> result = [];
    int len = arr.length - 1;
    for (var right = len; right >= 0; right--) {
      result.add(arr[right]);
    }
    return result;
  }
}
