import 'dart:io';

import 'package:tiga/src/context/httpResponseFeature.dart';



class Response {
  HttpResponse _response;

  Map<String, String> get headers {
    Map<String, String> _headers = {};
    _response.headers.forEach((k, v) {
      _headers[k] = v.join(";");
    });

    return _headers;
  }

  HttpResponse get body => _response;

  int get statusCode => _response.statusCode;

  set statusCode(int code) {
    _response.statusCode = code;
  }

  Response(HttpResponseFeature feature) {
    _response = feature.response;
  }

  Future writeAsync(String contents) async {
    await _response.write(contents);
  }
}
